package com.ff.weijinxiao.service;


import com.ff.weijinxiao.domain.OrderGoods;
import com.ff.weijinxiao.repository.OrderGoodsRepository;
import com.ff.weijinxiao.util.SpecificationUtil;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Pageable;
import org.springframework.data.domain.Sort;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;
import java.util.Optional;

@Service
public class OrderGoodsService {

    @Resource
    private OrderGoodsRepository orderGoodsRepository;

    /**
     * 创建实体
     *
     * @param orderGoods
     */
    public OrderGoods saveOrderGoods(OrderGoods orderGoods) {
        return orderGoodsRepository.save(orderGoods);
    }

    /**
     * 查找实体
     *
     * @param id
     * @return
     */
    public OrderGoods findById(Integer id) {
        Optional<OrderGoods> optional = orderGoodsRepository.findById(id);
        if (optional.isPresent()) {
            return optional.get();
        } else {
            return null;
        }
    }

    public OrderGoods findByOnlyID(String onlyID) {
        return orderGoodsRepository.findByOnlyID(onlyID);
    }

    public void deleteById(Integer id) {
        orderGoodsRepository.deleteById(id);
    }

    /**
     * 分页条件查询
     *
     * @param page
     * @param size
     * @param param
     * @return
     */
    public Page<OrderGoods> findPage(int page, int size, Map<String, Object> param) {
        Sort.Direction direction = Sort.Direction.DESC;
        String sort = "id";
        Pageable pageable = new PageRequest(page - 1, size, direction, sort);
        return orderGoodsRepository.findAll(SpecificationUtil.buildSpecification(param, OrderGoods.class), pageable);
    }

    /**
     * 根据条件查询List
     */
    public List<OrderGoods> findList(Map<String, Object> param) {
        return orderGoodsRepository.findAll(SpecificationUtil.buildSpecification(param, OrderGoods.class));
    }

}
